# Changelog

### 2023/09/06 v3.5.1
- _change_ -mオプションのレベル0は、自動実行ファイル作成方法を自動判別する既定の挙動に変更しました。

### 2023/08/27 v3.5.0

- _fix_ -m オプションが、HSP3_ROOT 環境変数もしくは、--hsp3root オプションによる HSP3 開発環境ディレクトリ未指定の状態で、hspc.exe 直下のディレクトリを自動選択しない不具合を修正しました。
  - umuy 様の記事を元に修正いたしました。記事の公開ありがとうございます。
    - https://qiita.com/umuy/items/8e8e6f1e4ccc0387be2c
  - MIZUSHIKI 様、インストーラーの作成と公開ありがとうございます。
    - https://dev.onionsoft.net/seed/info.ax?id=2317
- _feat_ -D オプションに追加の引数を実装しました。
  - -D オプションに数字を足すことで、処理のレベルを指定する事ができます。数字を省略した場合、0 を既定値とします。
  - -D0 で、従来のクリーンアップ処理を行います。
  - -D2 では、従来のクリーンアップ処理に続いて、packfile の削除を行います。
    - iconins.exe などの他のツール動作を考慮して、削除は約 5 秒後に行われます。それまで、hspc プロセスは待機します。
- _fix_ -m オプションを hsp37 以降のバージョンに対応しました。
  - その関係により、作成方法が追加されました。
  - --makerV3 オプションは、hsp37 対応の方法で自動実行ファイル作成を行います。
    - -m3 オプションは、--makerV3 オプションと同等です。
  - --makerV2 オプションは、従来の方法で自動実行ファイル作成を行います。
    - -m、-m0、-m2 オプションは、--makerV2 オプションと同等です。

onimata 様、コンテスト事務局様、お忙しい中、HSP3.7beta 対応化についてご教示いただきありがとうございました。

### 2023/08/26 v.3.4.3

- _fix_ hsp3root 値が設定されていない場合、-m オプションが機能しなかった不具合を修正しました。
- _fix_ hspcmp.dll を相対パスで読み込めてしまう恐れのあるコードを修正しました。

### 2022/11/20 v3.4.2

- _fix_ help コマンドに-w の項目漏れを修正しました。
- _fix_ readme ドキュメントに-w の説明漏れを修正しました。

### 2022/11/17 v3.4.1

- _fix_ compile コマンドの-w オプションが機能していない不具合を修正しました。

### 2022/09/27

- _fix_ readme の記述忘れを修正しました。
  - インストール・アンインストール
  - strmap の作成コマンド
  - lint のコマンド

### 2022/09/25 ver 3.4.0

- _fix_ `--strmap`オプションで`--compath`オプションが反映されない不具合を修正しました。
- _fix_ `--strmap`オプションが失敗したとき、正しい stat コードを表示していない不具合を修正しました。
- _fix_ lint コマンドの`--sethspcopt`オプションが反映されない不具合を修正しました。
- _feat_ 使用する HSP3 開発環境を指定できるようになりました。
  - `--hsp3root`オプション、HSP3_ROOT 環境変数に HSP3 開発環境のディレクトリを絶対パスで指定します。
  - HSP3_ROOT を無効化する HSPC_DISABLE_ENV_HSP3ROOT 環境変数も合わせて実装しました。
    - "true"文字列を設定することで、HSP3_ROOT を無効化します。既定値は"false"です。

### 2022/09/06 ver 3.3.5

- _fix_ `help` コマンドの不具合を修正しました。
- _add_ 現在読み込んでいる hspcmp.dll のパスが、`--version`で表示されるようになりました。

### 2021/10/24 ver 3.3.4

- _fix_ `help lint ls`の実装忘れを修正しました。

### 2021/10/19 ver 3.3.3

- _fix_ `help ls`が機能していない問題を修正しました。

### 2021/10/09 ver 3.3.2

- _fix_ 開発用デバッグ情報の出力を停止しました。
- _update_ 同梱する HSP のバージョンを 3.6 へ更新しました。

### 2021/09/30 ver b3.3.1

- _add_ `--nosubdir`オプションを実装しました。
- _update_ コンパイルコマンドで相対パスをそのまま取り扱うようになりました。
  - 対象はソースファイル、-C オプションによるカレントディレクトリです。
- _add_ `--version`オプションで自身のパスを表示するようになりました。

### 2021/08/31 ver b3.2.0

- _update_ コマンド名"watch"から"lint"へ変更しました。
  - フォルダの監視機能を`--watch`オプションとして実装し直しました。
  - hsc 系メソッド呼び出しからコンパイルコマンド呼び出しに変更しました。
    - `--addhspcopt`、`--sethspcopt`オプションを実装しました。
- _add_ lint のワイルドカード（MS=DOS 形式）による許可リスト、除外リストを実装しました。
  - `--allow`、`--ignore`オプションとして実装しました。

### 2021/07/21 ver b3.1.0

- _add_ hspw.exe から watch コマンドを移植しました。
- _add_ `--querylimit`オプションを実装しました。

### 2021/07/03 ver b3.0.0

- _feat_ hspc2 のコンパイル機能を相互に呼び出せるようにモジュール化しました。
- _remove_ テンプレート機能を削除しました。
- _add_ console.hsp モジュールを実装しました。
  - コンソールのコードページに合わせて標準出力をエンコードし直します。
  - VSCode などで文字化けする問題を解決しました。

### 2020/03/20 ver 2.0.4

- _fix_ IMultiLanguage2 の初期化に失敗してエラー 39 が発生してしまう不具合を修正しました。

### 2019/10/01 ver 2.0.3

- _fix_ hspc が引数の受け取りに失敗する不具合を修正しました。

### 2019/08/23 ver 2.0.2

- _fix_ `-r`で実行時に渡す引数にも、hspc の引数として解釈される問題を修正しました。

### 2019/08/12 ver 2.0.1

- _fix_ コマンド引数の解析に失敗しているのを修正しました。

### 2019/08/11 ver 2.0.0

- _add_ 実行時に コマンドライン（dir_cmdline）を渡せるようになりました。
  - `hspc -r app.hsp command line` もしくは、`hspc app.ax command line` で dir_cmdline に "command line" が格納されます。
- _fix_ 空白を含むパスを受け取れるようになりました。
  - これでディレクトリだけでなく、ファイル名に空白文字が存在しても正しく実行できます。
  - 必ず、ダブルクォーテーションで囲ってください。
- _update_ コマンドの順序が自由になりました。
  - `-dwr` はもちろん `-d -w -r` や `-dwr -oout` などの書き方ができるようになりました。
- _update_ コマンドプロンプトのカレントディレクトリを自動で捕捉します。
  - つまり、コマンドプロンプトのカレントディレクトリにあるファイルを相対パス`./source.hsp`で指定できるようになりました。
- _add_ `help`コマンドが追加されました。
  - `help <option>`でオプションの詳細な説明を表示することができます。
- _update_ `--compath`、`--rtmdir` で指定するパスの最後が"\\"でなかった場合、自動で"\\"を追加します。

### ~~2018/11/04 ver 1.4.4~~ 不具合のため、取り消されました。

- 空白文字を含むファイルパスを実行できない問題を修正しました。
- ダブルクォーテーション付きでソースファイルパスを渡されたら、正しく動作しない問題を修正しました。

### 2018/10/24 ver 1.4.3

- D オプションの不具合を修正しました。
- 自動実行ファイル作成で表示される、d オプションの警告文を変更しました。

### 2018/10/19 ver 1.4.2

- I オプションでカレントディレクトリ他、出力ファイル名とコモンディレクトリも表示するように変更しました。
  - 既定でコモンディレクトリは表示しないように仕様を戻しました。
- AX ファイルを然る後削除する D オプションを実装しました。

### 2018/10/18 ver 1.4.0

- カレントディレクトリを表示するように仕様変更しました。

### 2018/09/14 ver 1.3.3

- コードページの識別に失敗したとき、エラーを表示するようになりました。

### 2018/09/01 ver 1.3.2

- E オプションを実装しました。
  - コンパイルエラーが発生しても、プロセスは正常終了します。
    つまり、GetExitCodeProcess 関数の返り値は常に 0 です。

### 2018/08/29 ver 1.3.1

- a オプションが誤判定しやすい不具合を修正しました。

### 2018/08/28 ver 1.3.0

- a オプションを実装しました。
  - a オプション指定時に、ソースファイルのコードページを識別します。
  - UTF-8 だった場合、i オプションが追加指定されます。それ以外の場合、Shift_JIS として認識します。
- i オプションを実装しました。
  - ソースファイルを UTF-8 として認識します。指定しなかった場合、Shift_JIS として認識します。
- 自動実行ファイル作成時に hsc3_make 命令の iconins 使用フラグが立つようになりました。

### 2018/01/07 ver 1.2.0

- m オプション成功後、r オプションが実行されるように機能追加を行いました。

### 2017/09/07 ver 1.1.0

- 無効化されるようなオプションを警告する機能を追加しました。
- p オプション指定時に r と m オプションが実行されてしまう不具合を修正しました。

### 2017/09/04 ver 1.0.2

- p オプションが指定されているのに、r,m オプションが機能してしまう不具合を修正しました。
  - 通知を強化しました。

### 2017/08/31 ver 1.0.1

- エラーメッセージを適切な文に変更しました。

### 2017/08/22 ver 0.1.9

- コンソールのカレントディレクトリが反映されない環境に対処するため、**--rtmpath** オプションを廃止して、 **--cd** オプションにとりかわりました。
- **--cd** オプションは、作業ディレクトリを設定します。
  これにより、ソース指定に相対パスが使用できるようになりました。

### 2017/08/21 ver 0.1.8

- 引数付きオプションが機能していなかった不具合を修正しました。

### 2017/08/20 ver 0.1.7

- コマンド形態を見直し、見やすい書き方に変更しました。
  - 引数付きオプションの省略ができるようになりました。
- 処理フローのリファクタリング。

### 2017/08/15

- コマンド形態を作り直し。

### 2017/08/09

- 見切り発車でプログラムのフローを完成。
  - コマンドの形体は未確定。
